/*
 * RandomAutomatonFactory.h
 *
 *  Created on: 27. 3. 2014
 *      Author: Jan Travnicek
 */

#ifndef RANDOM_REG_EXP_FACTORY_H_
#define RANDOM_REG_EXP_FACTORY_H_

#include <set>
#include <vector>

#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp {

namespace generate {

class RandomRegExpFactory {
public:
	static regexp::UnboundedRegExp < > generateUnboundedRegExp( size_t leafNodes, size_t height, size_t alphabetSize, bool randomizedAlphabet );
	static regexp::UnboundedRegExp < > generateUnboundedRegExp( size_t leafNodes, size_t height, std::set < DefaultSymbolType > alphabet);

private:
	static regexp::UnboundedRegExp < > SimpleUnboundedRegExp( size_t n, size_t h, const std::vector < const regexp::UnboundedRegExpElement < DefaultSymbolType > * > & elems);
	static ext::rvalue_ref < regexp::UnboundedRegExpElement < DefaultSymbolType > > SimpleUnboundedRegExpElement(size_t n, size_t h, const std::vector < const regexp::UnboundedRegExpElement < DefaultSymbolType > * > & elems);
};

} /* namespace generate */

} /* namespace regexp */

#endif /* RANDOM_REG_EXP_FACTORY_H_ */
